#!/usr/local/bin/perl -w
#
# Output a particular channel's details in full
# (c) Andrew Flegg 2000. Released under the Artistic Licence
# http://www.opensource.org/licenses/artistic-license.html

use strict;
use CGI;
#use lib "/dcs/97/csube/tmp/tv";
use lib "/home/jaffa/bin/tv";
use Telly;

my $query = new CGI;
my $file  = $query->param('channel');

print $query->header('text/html');
$file     =~ s/[^A-Za-z0-9_]//g;
my $fname = "$Telly::DATA/$file.pm";
&error() if (! $file) or (! -f $fname);

do "$fname";
my @chnl = @{ $LISTINGS{$file} };

my $time = (stat($fname))[9];
my $nice =  &Telly::niceChannelName($file);
my $date =  scalar(gmtime($time));
$date    =~ s/^(\w+)\s+(\w+)\s+(\d+).*?\s+(\d+)$/$1, $3 $2 $4/;

print <<EOH;
<html>
<head>
<title>Today's Telly for $nice</title>

<style type="text/css"><!--
  body { margin:0px; }
  h1 {
    font-family: arial, helvetica, homerton, sans-serif;
    font-size: 200%;
  }

  .choice {
    font-family: arial, helvetica, homerton, sans-serif;
    font-size: 85%;
    font-weight: bold;
  }

  .msg {
    font-family: times, trinity, serif;
    font-size: 75%;
    margin-left: 30%;
    text-align: right;
  }

  .subtitle {
    font-family: times, trinity, serif;
    font-size: 80%;
    font-weight: bold;
  }
--></style>

</head>

<body bgcolor="#ffffff" text="#000000" link="#0000FF" vlink="#008080"
alink="#00ff00" marginwidth=0 marginheight=0 style="margin:0px;">
<table border=0 cellspacing=0 cellpadding=8>
<tr bgcolor="#ffcc66"><td bgcolor="#ffd884" valign="middle" align="center"
class="subtitle"><a href="/tv/">Today's UK TV</a><br>$date</td>
<td align="center">
<h1>$nice</h1>
</td></tr>

<tr>
<td width="10%" bgcolor="#ffdd99" valign="top" class="choice">
<i>Channels:</i><br>
EOH
# ------------------------------------------------------------------------

foreach my $i (&Telly::channelList()) {
    print "&nbsp;*&nbsp;<a href=\"channel.cgi?channel=$i\">";
    print &Telly::niceChannelName($i)."</a><br>\n";
}

# ------------------------------------------------------------------------
print <<EOH;
<br>&nbsp;<br>

<i>All Channels:</i><br>
&nbsp;*&nbsp;<a href="/cgi-bin/tv/all.cgi?desc=0">Terrestrial (small)</a><br>
&nbsp;*&nbsp;<a href="/cgi-bin/tv/all.cgi?desc=1">Terrestrial (big)</a><br>
</td>

<td width="90%" bgcolor="#fff0b0">
EOH
# ------------------------------------------------------------------------

my $fnt = '<font face="Arial,Helvetica,Homerton" size=2>';
print "<table cellpadding=0 cellspacing=3 border=0>";
foreach my $i (@chnl) {
    my ($time, $title, $desc) = @{ $i };

    my $bg = "";
    $bg = ' bgcolor="#dddddd"' if ($desc =~ m!(Film)!i);

    print"<tr><td valign=\"top\">$fnt<b>".niceTime($time)."</b></font></td>\n";
    print"<td$bg>$fnt<b>$title</b> $desc</font></td></tr>\n";
}
print "</table>";

# ------------------------------------------------------------------------
print <<EOH;
</td>
</tr>
</table>
<p class="msg">&copy; Andrew Flegg 2000. All rights reserved.<br>
This content is sourced from publically available content on the
Internet.<br>
Please <a href="mailto:andrew\@bleb.org">send</a> any suggestions to me.
The original pages are at <a 
href="http://www.bleb.org/tv/">Bleb.org</a>.</p>
EOH
exit;

#-- Oops, die ---------------------------
sub error {
    print <<EOH;
You fscked up!
EOH

    exit;
}
